#include "DxLib.h"
#include <math.h>

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	int ModelHandle ;
	int PixelShaderHandle ;
	int VertexShaderHandle ;
	float LightRotateAngle ;
	float ModelRotateAngle ;
	int DirLightHandle ;
	int PointLightHandle ;
	int SpotLightHandle ;
	VECTOR LightPosition ;
	
	// EChE[hŋN
	ChangeWindowMode( TRUE ) ;

	// cwCȕ
	if( DxLib_Init() < 0 )
	{
		// G[璼ɏI
		return -1 ;
	}


	// _VF[_[ǂݍ
	VertexShaderHandle = LoadVertexShader( "NormalMesh_DirSpotPointLight_NrmMapVS.vso" ) ;

	// sNZVF[_[ǂݍ
	PixelShaderHandle = LoadPixelShader( "NormalMesh_DirSpotPointLight_NrmMapPS.pso" ) ;


	// ̃bVfǂݍ
	ModelHandle = MV1LoadModel( "NormalBox_NrmMap.mv1" ) ;

	// f̉]px
	ModelRotateAngle = 0.0f ;


	// f̕`ɃIWiVF[_[gpݒnmɂ
	MV1SetUseOrigShader( TRUE ) ;

	// gp钸_VF[_[Zbg
	SetUseVertexShader( VertexShaderHandle ) ;

	// gpsNZVF[_[Zbg
	SetUsePixelShader( PixelShaderHandle ) ;


	// WCgItɂ
	SetLightEnable( FALSE ) ;

	// fBNViCg쐬
	DirLightHandle = CreateDirLightHandle( VGet( -1.0f, -1.0f, 0.0f ) ) ;

	// |CgCgnh쐬
	PointLightHandle = CreatePointLightHandle( VGet( 0.0f, 0.0f, 0.0f ), 1000.0f, 0.86f, 0.0000f, 0.0000f ) ;

	// X|bgCg쐬
	SpotLightHandle = CreateSpotLightHandle( VGet( 0.0f, 0.0f, 0.0f ), VGet( 0.0f, -1.0f, 0.0f ), 0.7f, 0.6f, 1000.0f, 0.391586f, 0.001662f, 0.0f ) ;

	// X|bgCg̃ArGgJ[𖳌ɂ
	SetLightAmbColorHandle( SpotLightHandle, GetColorF( 0.0f, 0.0f, 0.0f, 0.0f ) ) ;

	// X|bgCg̃fBt[YJ[΂ɂ
	SetLightDifColorHandle( SpotLightHandle, GetColorF( 0.0f, 1.0f, 0.0f, 0.0f ) ) ;

	// Cg̈ʒu]l
	LightRotateAngle = 0.0f ;


	// `𗠉ʂɂ
	SetDrawScreen( DX_SCREEN_BACK ) ;

	// f̌ʒuɃJzu
	SetCameraPositionAndTarget_UpVecY( VGet( 400.0f, 200.0f, -400.0f ), VGet( 0.0f, 0.0f, 0.0f ) ) ;


	// ESCL[܂Ń[v
	while( ProcessMessage() == 0 && CheckHitKey( KEY_INPUT_ESCAPE ) == 0 )
	{
		// ʂ
		ClearDrawScreen() ;

		// |CgCg̈ʒủ]lZ
		LightRotateAngle += 0.02f ;

		// |CgCg̈ʒu̍XV
		LightPosition.x = sin( LightRotateAngle ) * 600.0f ;
		LightPosition.y = 0.0f ;
		LightPosition.z = cos( LightRotateAngle ) * 600.0f ;
		SetLightPositionHandle( PointLightHandle, LightPosition ) ;

		// X|bgCg̈ʒu̍XV
		LightPosition.x = 0.0f ;
		LightPosition.y = cos( LightRotateAngle ) * 700.0f ;
		LightPosition.z = sin( LightRotateAngle ) * 700.0f ;
		SetLightPositionHandle( SpotLightHandle, LightPosition ) ;

		// Cǧ]Sɂ
		SetLightDirectionHandle( SpotLightHandle, VScale( LightPosition, -1.0f ) ) ;


		// f̉]lZ
		ModelRotateAngle += 0.002f ;

		// f̉]pxύX
		MV1SetRotationXYZ( ModelHandle, VGet( 0.0f, ModelRotateAngle, 0.0f ) ) ;


		// f`
		MV1DrawModel( ModelHandle ) ;

		// ʂ̓e\ʂɔf
		ScreenFlip() ;
	}

	// fBNViCg̍폜
	DeleteLightHandle( DirLightHandle ) ;

	// X|bgCg̍폜
	DeleteLightHandle( SpotLightHandle ) ;

	// |CgCg̍폜
	DeleteLightHandle( PointLightHandle ) ;

	// ǂݍ񂾒_VF[_[̍폜
	DeleteShader( VertexShaderHandle ) ;

	// ǂݍ񂾃sNZVF[_[̍폜
	DeleteShader( PixelShaderHandle ) ;

	// ǂݍ񂾃f̍폜
	MV1DeleteModel( ModelHandle ) ;

	// cwCǔn
	DxLib_End() ;

	// \tg̏I
	return 0 ;
}